#!/usr/bin/python
# -*- coding: koi8-r -*-
import pygtk
pygtk.require('2.0')
import gtk
import gobject

import os
import sys
import time
import zipfile
import StringIO

PROGRAM = 'metromap'
MAPINI = 'Metro.ini'

MD = None
MetroMap = None
Finder = None

dtime = 0
h = time.localtime()[3]
if h >= 21 or h <= 7:
        dtime = 1

CITY = None
XSIZE = None
YSIZE = None

import gettext

binpath = os.path.realpath(os.path.dirname(sys.argv[0]))
if binpath.endswith('/bin'): #FHS
        PREFIX = binpath[:binpath.rfind('/bin')]
        DATAPATH = PREFIX + '/share/' + PROGRAM + '/data/'
        MODULEPATH = PREFIX + '/share/' + PROGRAM + '/modules/'
        gettext.bindtextdomain(PROGRAM, PREFIX + '/share/locale/')
else:
        PREFIX = binpath
        DATAPATH = PREFIX + '/data/'
        MODULEPATH = PREFIX + '/modules/'
        gettext.bindtextdomain(PROGRAM, PREFIX + '/locale/')

sys.path.insert(1, MODULEPATH)
gettext.textdomain(PROGRAM)
_ = gettext.gettext

from ReadMap import ReadMap, GetMapName
from FindPath import FindPath

from MapDisplay import MapDisplay

import Interface
Interface._ = _

RCDIR = os.environ.get('HOME') + "/." + PROGRAM
if not os.path.isdir(RCDIR):
        try:
                os.mkdir(RCDIR)
        except:
                pass

if os.path.isfile(RCDIR + "/rc"):
        f = file(RCDIR + "/rc", 'r')
        done = False
        while not done:
                s = f.readline()
                if not s:
                        break
                p = s.split('=')
                if len(p) == 2:
                        if p[0] == 'city':
                                CITY = p[1].rstrip()
                        elif p[0] == 'xsize':
                                XSIZE = int(p[1].rstrip())
                        elif p[0] == 'ysize':
                                YSIZE = int(p[1].rstrip())
        f.close()

def atexit(foo):
        try:
                f = file(RCDIR + "/rc", 'w')
                f.write('city=' + CITY + '\n')
                f.write('xsize=' + str(Iface.xsize) + '\n')
                f.write('ysize=' + str(Iface.ysize) + '\n')
                f.close()
        except:
                pass
        gtk.main_quit()

st_start = None
st_end = None
path_list = list()

def ciext_file_find(path, name, ext):
        for f in os.listdir(path):
                if f.startswith(name) and len(f) == len(name) + len(ext) + 1 and \
                   f[-len(ext):].lower() == ext.lower():
                        return f
        #not found, return some shit
        return name + '.' + ext

def get_data_full(datapath, city, filename):
        f = None
        n = None
        try:
                n = datapath + city + '/' + filename
                f = open(n)
        except:
                try:
                        n = datapath + ciext_file_find(datapath, city, 'pmz')
                        z = zipfile.ZipFile(n, 'r')
                        f = StringIO.StringIO(z.read(filename))
                        z.close()
                except:
                        try:
                                n = datapath + ciext_file_find(datapath, city, 'zip')
                                z = zipfile.ZipFile(n, 'r')
                                intn = city + '.pmz'
                                for zn in z.namelist():
                                        if zn.lower() == city.lower() + '.pmz':
                                                intn = zn
                                                break
                                pmzf = StringIO.StringIO(z.read(intn))
                                z.close()
                                z = zipfile.ZipFile(pmzf, 'r')
                                f = StringIO.StringIO(z.read(filename))
                                z.close()
                        except:
                                n = _("unknown")
                                f = None
        return n, f

def get_data(city, filename):
        for dp in DATAPATH, RCDIR + '/':
                n, f = get_data_full(dp, city, filename)
                if f:
                        break
        return n, f

citylist = list()
for dp in DATAPATH, RCDIR + '/':
        if not os.path.isdir(dp):
                continue
        for c in os.listdir(dp):
                cn = c
                if c.lower().endswith('.zip') or c.lower().endswith('.pmz'):
                        cn = c[:-4]
                n, f = get_data_full(dp, cn, 'Metro.ini')
                if f:
                        name = GetMapName(f)
                        f.close()
                        if name:
                                citylist.append((name, cn))

if len(citylist) == 0:
        print unicode(_('No data files found, please install some.'))
        sys.exit(0)

if not CITY or not len(filter(lambda a: a[1] == CITY, citylist)):
        if len(filter(lambda a: a[1] == "Moscow", citylist)):
                CITY = "Moscow"
        else:
                CITY = citylist[0][1]

def station_selected(station, isstart):
        global st_start, st_end, path_list

        if st_start != station and st_end != station:
                if isstart:
                        st_start = station
                        Iface.set_from(station)
                        MD.set_start_station(station)
                else:
                        st_end = station
                        Iface.set_to(station)
                        MD.set_stop_station(station)

                if st_start != None and st_end != None:
                        path_list = Finder.waves_accurate(st_start, st_end, MetroMap.WaitLen)
                        path_list.sort()

                if len(path_list):
                        MD.set_path_list(path_list[0][2:])
                else:
                        MD.set_path_list(None)

                Iface.set_path_list(map(lambda a: _("Minutes: %d Changes: %d") % (a[0], a[1]), path_list))

def list_selected(num):
        global path_list

        if path_list and num < len(path_list):
                MD.set_path_list(path_list[num][2:])

def city_changed(name):
        global st_start, st_end, path_list, MetroMap, MD, Finder, prefs, CITY, dtime

        CITY = name
        st_start = st_end = None
        path_list = list()
        n, f = get_data(CITY, MAPINI)
        if not f:
                print unicode(_('Cannot find Metro.ini for city "') + CITY + '"')
                sys.exit(0)
        MetroMap = ReadMap(f)
        f.close()
        MetroMap.SetDelayTime(dtime)
        snames = map(lambda a: ["%s (%s)" % (a['name'], MetroMap.Lines[a['line']]['name']), a['number']], MetroMap.Stations.values())
        snames.sort()

        MD = MapDisplay(MetroMap.Lines, MetroMap.Stations, MetroMap.Map['vectors'], station_selected)

        Iface.set_path_list([])
        Iface.set_da(MD.da)
        Iface.set_st_list(snames)
        Iface.set_dtime(dtime)
        Iface.set_win_title(PROGRAM + ' - ' + MetroMap.Map['city'])
        if not Finder:
                Finder = FindPath(MetroMap.Graph)
        else:
                Finder.set_graph(MetroMap.Graph)

def dtime_changed(num):
        global MetroMap, dtime, st_start

        if num != dtime:
                dtime = num
                MetroMap.SetDelayTime(dtime)
                if st_start: #recalculate path's
                        station = st_start
                        st_start = None
                        station_selected(station, True)

Iface = Interface.Interface(PROGRAM, None, None, citylist = citylist,
                            citynow = CITY, xsize = XSIZE, ysize = YSIZE)
Iface.win.connect('destroy', atexit)
Iface.set_path_cb(list_selected)
Iface.set_station_cb(station_selected)
Iface.set_city_cb(city_changed)
Iface.set_dtime_cb(dtime_changed)

city_changed(CITY)

gtk.main()
